//BrainStorm mkH

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.filechooser.*;
import java.lang.Math;
import java.util.*;
import java.io.*;

class Verbindung
{
	
	//Attribute
	static boolean verbindung_info_offen;
	Info header;
	String beschriftung;
	String stereotyp;
	String stereotypbuffer;
	String zusicherung;
	String zusicherungbuffer;
	String linientyp;
	Knoten knoten1,knoten2;
	
	//Konstruktor
	Verbindung()
	{
		verbindung_info_offen=false;
		header = new Info();
		beschriftung="";
		stereotyp = "";
		stereotypbuffer="";
		zusicherung = "";
		zusicherungbuffer="";
		linientyp="";		
		knoten1 = new Knoten("","","");
		knoten2 = new Knoten("","","");
	}
	
	//Methode: editieren
	public void edit()
	{
		Gui_Verbindungen my_verbindungen_gui = new Gui_Verbindungen();
		my_verbindungen_gui.setVisible(true);
		my_verbindungen_gui.pack();
	}
	
	//Methode: save
	public void save(File filename) throws Exception
	{
		XML xmlverb=new XML();
		xmlverb.writeTag("verbindung",0);
		xmlverb.writeChar("\n");
		
		header.write(xmlverb);
		
		xmlverb.writeTag("body",2);
		xmlverb.writeChar("\n");
		
		xmlverb.writeTag("beschriftung",4);
		xmlverb.writeString(beschriftung);
		xmlverb.writeTag("/beschriftung",0);
		xmlverb.writeChar("\n");
		
		xmlverb.writeTag("zusicherung",4);
		xmlverb.writeString(zusicherung);
		xmlverb.writeTag("/zusicherung",0);
		xmlverb.writeChar("\n");
		
		xmlverb.writeTag("stereotyp",4);
		xmlverb.writeString(stereotyp);
		xmlverb.writeTag("/stereotyp",0);
		xmlverb.writeChar("\n");
		
		xmlverb.writeTag("linientyp",4);
		xmlverb.writeString(linientyp);
		xmlverb.writeTag("/linientyp",0);
		xmlverb.writeChar("\n");
		
		xmlverb.writeTag("knoten",4);
		xmlverb.writeChar("\n");
		
		xmlverb.writeTag("pfeiltyp",6);
		xmlverb.writeString(knoten1.pfeiltyp);
		xmlverb.writeTag("/pfeiltyp",0);
		xmlverb.writeChar("\n");
		
		xmlverb.writeTag("multiplikator",6);
		xmlverb.writeString(knoten1.multiplikator);
		xmlverb.writeTag("/multiplikator",0);
		xmlverb.writeChar("\n");
		
		xmlverb.writeTag("zusicherung",6);
		xmlverb.writeString(knoten1.zusicherung_knoten);
		xmlverb.writeTag("/zusicherung",0);
		xmlverb.writeChar("\n");
		
		xmlverb.writeTag("/knoten",4);
		xmlverb.writeChar("\n");
		
		xmlverb.writeTag("knoten",4);
		xmlverb.writeChar("\n");
		
		xmlverb.writeTag("pfeiltyp",6);
		xmlverb.writeString(knoten2.pfeiltyp);
		xmlverb.writeTag("/pfeiltyp",0);
		xmlverb.writeChar("\n");
		
		xmlverb.writeTag("multiplikator",6);
		xmlverb.writeString(knoten2.multiplikator);
		xmlverb.writeTag("/multiplikator",0);
		xmlverb.writeChar("\n");
		
		xmlverb.writeTag("zusicherung",6);
		xmlverb.writeString(knoten2.zusicherung_knoten);
		xmlverb.writeTag("/zusicherung",0);
		xmlverb.writeChar("\n");
		
		xmlverb.writeTag("/knoten",4);
		xmlverb.writeChar("\n");
		
		xmlverb.writeTag("/body",2);
		xmlverb.writeChar("\n");
		
		xmlverb.writeTag("/verbindung",0);
		xmlverb.writeChar("\n");
		
		xmlverb.saveXml(filename);
	}
	
	//Methode: laden
	public void load(File filename) throws Exception
	{
		XML xmlverb=new XML();
		String	tag;
		String	mapfeiltyp;
		String	mamultiplikator;
		String	mazusicherung;
		int	knotencount=0;
		
		header.filename=filename.getPath();
		
		xmlverb.loadXml(filename);
		tag=xmlverb.getTag();
		if (!tag.equals("verbindung"))
		{
			throw new Exception("Diese Datei enthaelt keine Verbindung!");
		}
		do
		{
			tag=xmlverb.getTag();
			if (tag.equals("header"))
			{
				header.read(xmlverb);				
			}
			else//1
			{
				if (tag.equals("body"))
				{
					do
					{
						tag=xmlverb.getTag();
						if (tag.equals("beschriftung"))
						{
							if(!beschriftung.equals(""))
							{
								throw new Exception("Beschriftung schon vorhanden");
							}
							else
							{
								beschriftung=xmlverb.getString("beschriftung");
							}
						}
						else//2
						{
							if (tag.equals("stereotyp"))
							{
								if(!stereotypbuffer.equals(""))
								{
									throw new Exception("Stereotyp schon vorhanden");
								}
								else
								{
									stereotypbuffer=xmlverb.getString("stereotyp");
								}
							}
							else//3
							{
								if (tag.equals("zusicherung"))
								{
									if (!zusicherungbuffer.equals(""))
									{
										throw new Exception("Zusicherung schon vorhanden");
									}
									else
									{
										zusicherungbuffer=xmlverb.getString("zusicherung");
									}
								}
								else//4
								{   
									if(tag.equals("linientyp"))
									{
										if(!linientyp.equals(""))
										{
											throw new Exception("Linientyp schon vorhanden");
										}
										else
										{
											linientyp=xmlverb.getString("linientyp");
										}
									}
									else//5
									{
										if(tag.equals("knoten"))
										{
											mapfeiltyp="";
											mamultiplikator="";
											mazusicherung="";   										
											do
											{      tag=xmlverb.getTag();//
												if(tag.equals("pfeiltyp"))
												{
													if(!mapfeiltyp.equals(""))
													{
														System.out.println("Pro Knoten nur ein Pfeiltyp erlaubt");
													} 
													else
													{
														mapfeiltyp=xmlverb.getString("pfeiltyp");
													}
												}//if(tag.equals("pfeiltyp"))
												else //6
												{
													if (tag.equals("multiplikator"))
													{
														if (!mamultiplikator.equals(""))
														{
															System.out.println("Pro Knoten nur ein Multiplikator erlaubt");
														}
														else
														{
															mamultiplikator=xmlverb.getString("multiplikator");
														}
													}//if (tag.equals("multiplikator"))
													else 
													{//7
														if (tag.equals("zusicherung"))
														{
															if (!mazusicherung.equals(""))
															{
																System.out.println("Pro Knoten nur eine Zusicherung erlaubt");
															}
															else
															{
																mazusicherung=xmlverb.getString("zusicherung");
															}
														}//if (tag.equals("zusicherung"))
														else
														{//8
															if (!tag.equals("/knoten"))
															{
																xmlverb.skipTag(tag);
															}
														} //8
													} //7
												} //6 											
											}while(!tag.equals("/knoten")); //5		                                                                       
											if (knotencount==0)
											{
												knoten1.pfeiltyp=mapfeiltyp;
												knoten1.multiplikator=mamultiplikator;
												knoten1.zusicherung_knoten=mazusicherung;
											}
											else
											{
												if (knotencount==1)
												{  
													knoten2.pfeiltyp=mapfeiltyp;
													knoten2.multiplikator=mamultiplikator;
													knoten2.zusicherung_knoten=mazusicherung;
												}
												else
												{
													System.out.println("Nur zwei Knoten pro Verbindung erlaubt");
												}
											}//ELSE 											
											knotencount++; 
										}//if knoten
										else
										{
											if (!tag.equals("/body"))
											{
												xmlverb.skipTag(tag);
											}
										}
									}//5
								}//4
							} // 3
						} // 2
					} while (!tag.equals("/body"));  					
				} // if body
				else
				{
					if(!tag.equals("/verbindung"))
					{
						throw new Exception("nix anderes");
					}
				}
			} // 1
			
		} while(!tag.equals("/verbindung"));
		edit();		
	}//load
	
	//Datentyp: Knoten
	class Knoten
	{
		String pfeiltyp;
		String multiplikator;
		String zusicherung_knoten;
		
		Knoten(String p,String m, String z)
		{
			pfeiltyp= p;
			multiplikator=m;
			zusicherung_knoten=z;
		}
	}
	
	//GUI
	class Gui_Verbindungen extends JFrame
	{
		final JFileChooser fc = new JFileChooser();
		
		JPanel content_pane = new JPanel();
		
		JPanel left = new JPanel();
		JPanel right = new JPanel();
		
		JPanel right_buttons = new JPanel();
		
		JPanel one1 = new JPanel();
		JPanel one11 = new JPanel();
		JPanel oneall = new JPanel();
		
		JPanel two1 = new JPanel();
		JPanel two2 = new JPanel();
		JPanel two3 = new JPanel();
		JPanel two4 = new JPanel();
		JPanel twoall = new JPanel();
		
		JPanel three1 = new JPanel();
		JPanel three2 = new JPanel();
		JPanel three3 = new JPanel();
		JPanel threeall = new JPanel();
		
		JPanel four1 = new JPanel();
		JPanel four2 = new JPanel();
		JPanel four3 = new JPanel();
		JPanel fourall = new JPanel();
		
		JPanel left2 = new JPanel();
		
		JSplitPane my_splitter = new JSplitPane(1, left, right);
		
		//TextFields des Reiters "Allgemein"
		JTextField connection_name = new JTextField(header.info_name,10);		
		
		JTextField indication = new JTextField(beschriftung,10);
		JTextField stereotype = new JTextField(stereotypbuffer,10);
		JTextField indication_assurance = new JTextField(zusicherungbuffer,10);
		String text="";
		String zahl_links="";String zusicherung_links="";String zahl_rechts="";String zusicherung_rechts="";
		int indicator = 0;
		int indicator2 =0;
		int indicator3 =0;
		int indicator4 =0;
		int j = 0;
		int[] a,b,c,d;
		FontMetrics m ;
		//TextFields des Reiters "Links/Oben"
		JTextField left_top_number = new JTextField(knoten1.multiplikator,10);
		JTextField left_top_assurance = new JTextField(knoten1.zusicherung_knoten,10);
		
		//TextFields des Reiters "Rechts/Unten"
		JTextField right_down_number = new JTextField(knoten2.multiplikator,10);
		JTextField right_down_assurance = new JTextField(knoten2.zusicherung_knoten,10);
		
		JButton info = new JButton("Info");
		
		JButton right_button1 = new JButton("Anzeigen");
		JButton right_button2 = new JButton("OK");
		JButton right_button3 = new JButton("Abbrechen");
		
		MyCanvas paint_canvas = new MyCanvas();
		
		
		JComboBox scope_linetype = new JComboBox();
		JComboBox scope_left_top_arrowtype = new JComboBox();
		JComboBox scope_right_down_arrowtype = new JComboBox();
		JComboBox right_detail = new JComboBox();
		
		//JTextArea text_area1 = new JTextArea(5, 15);
		
		ActionListener on_right_buttons = new RightButtonsListener();
		ActionListener on_right_detail = new RightDetailListener();
		//Construct the frame
		public Gui_Verbindungen()
		{
			enableEvents(AWTEvent.WINDOW_EVENT_MASK);
			try
			{
				init();
			}
			catch(Exception e)
			{
				e.printStackTrace();
			}
		}
		
		//Component initialization
		private void init()
		{
			this.setContentPane(content_pane);
			this.setSize(new Dimension(400,300));
			this.setTitle("Verbindung editieren");
			this.setIconImage((new ImageIcon("brain.jpg")).getImage());
			
			content_pane.add(my_splitter);
			
			left.setLayout(new BorderLayout());
			right.setLayout(new BorderLayout());
			
			paint_canvas.setSize(new Dimension(400,420));
			paint_canvas.setBackground(new Color(255, 255,255));
			
			scope_linetype.setBackground(new Color(255, 255, 255));
			scope_linetype.addItem("durchgezogen");
			scope_linetype.addItem("gestrichelt");
			if(!linientyp.equals(""))
			scope_linetype.setSelectedItem(linientyp);
			
			
			scope_left_top_arrowtype.setBackground(new Color(255, 255, 255));
			scope_left_top_arrowtype.addItem("leer");
			scope_left_top_arrowtype.addItem("einfach");
			scope_left_top_arrowtype.addItem("Dreieck");
			scope_left_top_arrowtype.addItem("Dreieck-gefuellt");
			scope_left_top_arrowtype.addItem("Raute");
			scope_left_top_arrowtype.addItem("Raute-gefuellt");
			if(!knoten1.pfeiltyp.equals(""))
			scope_left_top_arrowtype.setSelectedItem(knoten1.pfeiltyp);
			
			scope_right_down_arrowtype.setBackground(new Color(255, 255, 255));
			scope_right_down_arrowtype.addItem("leer");
			scope_right_down_arrowtype.addItem("einfach");
			scope_right_down_arrowtype.addItem("Dreieck");
			scope_right_down_arrowtype.addItem("Dreieck-gefuellt");
			scope_right_down_arrowtype.addItem("Raute");
			scope_right_down_arrowtype.addItem("Raute-gefuellt");
			if(!knoten2.pfeiltyp.equals(""))
			scope_right_down_arrowtype.setSelectedItem(knoten2.pfeiltyp);
			
			right_detail.setBackground(new Color(255, 255, 255));
			right_detail.setToolTipText("Detailierungsgrad");
			right_detail.addItem("hoch");
			right_detail.addItem("mittel");
			right_detail.addItem("niedrig");
			
			one1.setLayout(new BorderLayout());
			one1.add(info, BorderLayout.EAST);
			one1.add(one11, BorderLayout.WEST);
			
			one11.setLayout(new GridLayout(1,2));
			one11.add(new JLabel("Name"));
			one11.add(connection_name);
			
			oneall.setPreferredSize(new Dimension(400,50));
			oneall.setLayout(new BorderLayout());
			oneall.setBorder(new TitledBorder("Allgemein"));
			oneall.add(one1, BorderLayout.CENTER);
			
			
			two1.setLayout(new BorderLayout());
			two1.add(new JLabel("Bezeichnung:"),BorderLayout.WEST);
			two1.add(indication,BorderLayout.EAST);
			
			
			two2.setLayout(new BorderLayout());
			two2.add(new JLabel("Stereotyp:"), BorderLayout.WEST);
			two2.add(stereotype, BorderLayout.EAST);
			
			two3.setLayout(new BorderLayout());
			two3.add(new JLabel("Zusicherungen:"), BorderLayout.WEST);
			two3.add(indication_assurance, BorderLayout.EAST);
			
			two4.setLayout(new BorderLayout());
			two4.add(new JLabel("Linientyp:"),BorderLayout.WEST);
			two4.add(scope_linetype, BorderLayout.EAST);
			
			twoall.setLayout(new GridLayout(4,1));
			twoall.setBorder(new TitledBorder("Linie"));
			twoall.add(two1);
			twoall.add(two2);
			twoall.add(two3);
			twoall.add(two4);
			
			three1.setLayout(new BorderLayout());
			three1.add(new JLabel("Pfeilart:"),BorderLayout.WEST);
			three1.add(scope_left_top_arrowtype,BorderLayout.EAST);
			
			three2.setLayout(new BorderLayout());
			three2.add(new JLabel("Multiplizitt:"),BorderLayout.WEST);
			three2.add(left_top_number,BorderLayout.EAST);
			
			three3.setLayout(new BorderLayout());
			three3.add(new JLabel("Zusicherung:"),BorderLayout.WEST);
			three3.add(left_top_assurance,BorderLayout.EAST);
			
			threeall.setLayout(new GridLayout(3,1));
			threeall.setBorder(new TitledBorder("Linkes bzw oberes Pfeilende"));
			threeall.add(three1);
			threeall.add(three2);
			threeall.add(three3);
			
			four1.setLayout(new BorderLayout());
			four1.add(new JLabel("Pfeilart:"),BorderLayout.WEST);
			four1.add(scope_right_down_arrowtype,BorderLayout.EAST);
			
			four2.setLayout(new BorderLayout());
			four2.add(new JLabel("Multiplizitt:"),BorderLayout.WEST);
			four2.add(right_down_number,BorderLayout.EAST);
			
			four3.setLayout(new BorderLayout());
			four3.add(new JLabel("Zusicherung:"),BorderLayout.WEST);
			four3.add(right_down_assurance,BorderLayout.EAST);
			
			fourall.setLayout(new GridLayout(3,1));
			fourall.setBorder(new TitledBorder("Rechtes bzw unteres Pfeilende"));
			fourall.add(four1);
			fourall.add(four2);
			fourall.add(four3);
			
			
			left2.setLayout(new GridLayout(3,1));
			left2.add(twoall);
			left2.add(threeall);
			left2.add(fourall);
			
			left.add(oneall,BorderLayout.NORTH);
			left.add(left2,BorderLayout.SOUTH);
			
			right_buttons.setLayout(new GridLayout(0, 4));
			right_buttons.add(right_button1);
			right_buttons.add(right_detail);
			right_buttons.add(right_button2);
			right_buttons.add(right_button3);
			
			right.add(paint_canvas, BorderLayout.NORTH);
			right.add(right_buttons, BorderLayout.SOUTH);
			
			info.addActionListener(on_right_buttons);
			right_button1.addActionListener(on_right_buttons);
			right_button2.addActionListener(on_right_buttons);
			right_button3.addActionListener(on_right_buttons);
			right_detail.addActionListener(on_right_detail);
		}
		
		public class RightDetailListener implements ActionListener
		{
			public void actionPerformed(ActionEvent e)
			{
				if(right_detail.getSelectedItem()=="hoch")
				{
					indicator4=0;
					paint_canvas.repaint();
				}
				if(right_detail.getSelectedItem()=="mittel")
				{
					indicator4=1;
					paint_canvas.repaint();
				}
				if(right_detail.getSelectedItem()=="niedrig")
				{
					indicator4=2;
					paint_canvas.repaint();
				}
			}
		}
		
		public class RightButtonsListener implements ActionListener
		{
			public void actionPerformed(ActionEvent e)
			{
				if(e.getActionCommand()=="Info")
				{
					if (verbindung_info_offen==false)
					{
						header.info_name=connection_name.getText();
						verbindung_info_offen=true;
						header.edit("Informationen der Verbindung: "+header.info_name,"verbindung");
					}
				}
				
				if(e.getActionCommand()=="Anzeigen")
				{
					text = indication.getText();
					stereotyp = stereotype.getText();
					zusicherung = indication_assurance.getText();
					zahl_links = left_top_number.getText();
					zusicherung_links = left_top_assurance.getText();
					zahl_rechts = right_down_number.getText();
					zusicherung_rechts = right_down_assurance.getText();
					if(scope_linetype.getSelectedItem().equals("durchgezogen")) indicator = 1;
					if(scope_linetype.getSelectedItem().equals("gestrichelt")) indicator = 2;
					
					if(scope_left_top_arrowtype.getSelectedItem().equals("leer")){indicator2 = 0;}
					if(scope_left_top_arrowtype.getSelectedItem().equals("einfach")){indicator2 = 1;}
					if(scope_left_top_arrowtype.getSelectedItem().equals("Dreieck")){indicator2 = 2;}
					if(scope_left_top_arrowtype.getSelectedItem().equals("Dreieck-gefuellt")){indicator2 = 3;}
					if(scope_left_top_arrowtype.getSelectedItem().equals("Raute")){indicator2 = 4;}
					if(scope_left_top_arrowtype.getSelectedItem().equals("Raute-gefuellt")){indicator2 = 5;}
					
					if(scope_right_down_arrowtype.getSelectedItem().equals("leer")){indicator3= 0;}
					if(scope_right_down_arrowtype.getSelectedItem().equals("einfach")){indicator3= 1;}
					if(scope_right_down_arrowtype.getSelectedItem().equals("Dreieck")){indicator3= 2;}
					if(scope_right_down_arrowtype.getSelectedItem().equals("Dreieck-gefuellt")){indicator3= 3;}
					if(scope_right_down_arrowtype.getSelectedItem().equals("Raute")){indicator3= 4;}
					if(scope_right_down_arrowtype.getSelectedItem().equals("Raute-gefuellt")){indicator3= 5;}
					
					if(right_detail.getSelectedItem().equals("hoch")){indicator4=0;}
					if(right_detail.getSelectedItem().equals("mittel")){indicator4=1;}
					if(right_detail.getSelectedItem().equals("niedrig")){indicator4=2;}
					paint_canvas.repaint();					
				}
				
				if(e.getActionCommand()=="OK")
				{
					//interne Speicherung der allgemeinen Daten
					header.info_name=connection_name.getText();
					stereotyp=stereotype.getText();
					beschriftung=indication.getText();
					zusicherung=indication_assurance.getText();
					linientyp=scope_linetype.getSelectedItem().toString();
					//interne Speicherung des linken/oberen Knotens
					knoten1.pfeiltyp=scope_left_top_arrowtype.getSelectedItem().toString();
					knoten1.multiplikator=left_top_number.getText();
					knoten1.zusicherung_knoten=left_top_assurance.getText();
					//interne Speicherung des rechten/unteren Knotens
					knoten2.pfeiltyp=scope_right_down_arrowtype.getSelectedItem().toString();
					knoten2.multiplikator=right_down_number.getText();
					knoten2.zusicherung_knoten=right_down_assurance.getText();
					
					fc.setDialogTitle("Verbindung speichern");
					File default_file=new File(header.filename);
					fc.setSelectedFile(default_file);
					int returnVal =fc.showSaveDialog(Gui_Verbindungen.this);
					if(returnVal == JFileChooser.APPROVE_OPTION)
					{
						try
						{
							File file = fc.getSelectedFile();
							save(file);
							UMLTOPP.verbindung_offen=false;
							dispose();
						}
						catch(Exception f)
						{
							JOptionPane test = new JOptionPane();
							test.showMessageDialog(getParent(), f.getMessage(),"Fehlermeldung",JOptionPane.ERROR_MESSAGE);
						}
					}
				}
				
				if(e.getActionCommand()=="Abbrechen")
				{
					Object[] test = { "OK", "CANCEL" };
					JOptionPane jop = new JOptionPane();
					int inputvalue = jop.showOptionDialog(null, "Abbrechen ohne zu speichern? Daten knnen verloren gehen!", "Warning",JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE, null, test, test[0]);
					
					if(inputvalue == JOptionPane.OK_OPTION)
					{
						UMLTOPP.verbindung_offen=false;
						dispose();
					} 
				}
			}
		}
		
		//Overridden so we can exit when window is closed
		protected void processWindowEvent(WindowEvent e)
		{
			super.processWindowEvent(e);
			if (e.getID() == WindowEvent.WINDOW_CLOSING)
			{
				UMLTOPP.verbindung_offen=false;
				this.dispose();
			}
		}
		
		public class MyCanvas extends Canvas
		{
			MyCanvas()
			{
				setBackground(Color.white);
				setForeground(Color.black);
			}
			
			public void paint(Graphics g)
			{
				
				j=Math.max(Math.max(this.getFontMetrics(this.getFont()).stringWidth(text+zahl_links+zahl_rechts),
					this.getFontMetrics(this.getFont()).stringWidth(stereotyp+zahl_links+zahl_rechts)),
					this.getFontMetrics(this.getFont()).stringWidth(zusicherung+zahl_links+zahl_rechts))
					+70;
				if(stereotyp.length()>0)j=j+this.getFontMetrics(this.getFont()).stringWidth("<<>>");
				
				if(zusicherung.length()>0)j=j+this.getFontMetrics(this.getFont()).stringWidth("{}");
				
				if(indicator == 1)
				{
					g.drawLine(30,60,j,60);
				}
				
				if(indicator == 2)
				{	
					int i=30;
					while(i<j)
					{
						g.drawLine(i,60,i+5,60);
						i=i+10;
					}  
				}
				if((text.length()> 0)&& (!(indicator4== 2)))
				{
					g.drawString(text,this.getFontMetrics(this.getFont()).stringWidth(zahl_links)+50,40);
				}
				
				if(indicator4==0)
				{
					if(stereotyp.length()>0)
					{
						g.drawString(stereotyp,this.getFontMetrics(this.getFont()).stringWidth(zahl_links)+50+
							this.getFontMetrics(this.getFont()).stringWidth("<<"),30);
						g.drawString("<<",this.getFontMetrics(this.getFont()).stringWidth(zahl_links)+50,30);
						g.drawString(">>", this.getFontMetrics(this.getFont()).stringWidth(stereotyp)+
							this.getFontMetrics(this.getFont()).stringWidth("<<")+
							this.getFontMetrics(this.getFont()).stringWidth(zahl_links)+50,30);
					}
					if(zusicherung.length()>0)
					{
						g.drawString(zusicherung,this.getFontMetrics(this.getFont()).stringWidth(zahl_links)+50+
							this.getFontMetrics(this.getFont()).stringWidth("{"),50);
						g.drawString("{",this.getFontMetrics(this.getFont()).stringWidth(zahl_links)+50,50);
						g.drawString("}",this.getFontMetrics(this.getFont()).stringWidth(zusicherung)+
							this.getFontMetrics(this.getFont()).stringWidth("{")+
							this.getFontMetrics(this.getFont()).stringWidth(zahl_links)+50,50);
					}
					if(zahl_links.length()>0)g.drawString(zahl_links,40,50);
					if(zahl_rechts.length()>0) g.drawString(zahl_rechts,j-this.getFontMetrics(this.getFont()).stringWidth(zahl_rechts)-10,50);
					if(zusicherung_links.length()>0) g.drawString(zusicherung_links,40,70);
					if(zusicherung_rechts.length()>0) g.drawString(zusicherung_rechts,j-this.getFontMetrics(this.getFont()).stringWidth(zahl_rechts)-10,80);
				}
				
				if(indicator2 == 0){;}
				if(indicator2 == 1)
				{
					g.drawLine(30,60,45,56);
					g.drawLine(30,60,45,64);
				}
				
				if(indicator2 == 2)
				{
					a = new int[3];a[0]=15;a[1]=30;a[2]=30;
					b = new int[3];b[0]=60;b[1]=56;b[2]=64;
					g.drawPolygon(a,b,3);
				}
				if(indicator2 == 3)
				{
					a = new int[3];a[0]=15;a[1]=30;a[2]=30;
					b = new int[3];b[0]=60;b[1]=56;b[2]=64;
					g.drawPolygon(a,b,3);
					g.fillPolygon(a,b,3);
				}
				if(indicator2 == 4)
				{
					a = new int[4];a[0]=10;a[1]=20;a[2]=30;a[3]=20;
					b = new int[4];b[0]=60;b[1]=55;b[2]=60;b[3]=65;
					g.drawPolygon(a,b,4);
				}
				if(indicator2 == 5)
				{
					a = new int[4];a[0]=10;a[1]=20;a[2]=30;a[3]=20;
					b = new int[4];b[0]=60;b[1]=55;b[2]=60;b[3]=65;
					g.drawPolygon(a,b,4);
					g.fillPolygon(a,b,4);
				}
				if(indicator3 == 0){;}
				if(indicator3 == 1)
				{
					g.drawLine(j,60,j-15,56);
					g.drawLine(j,60,j-15,64);
				}
				if(indicator3 == 2)
				{
					a = new int[3];a[0]=j+15;a[1]=j;a[2]=j;
					b = new int[3];b[0]=60;b[1]=56;b[2]=64;
					g.drawPolygon(a,b,3);
				}
				if(indicator3 == 3)
				{
					a = new int[3];a[0]=j+15;a[1]=j;a[2]=j;
					b = new int[3];b[0]=60;b[1]=56;b[2]=64;
					g.drawPolygon(a,b,3);
					g.fillPolygon(a,b,3);
				}
				if(indicator3 == 4)
				{
					a = new int[4];a[0]=j;a[1]=j+10;a[2]=j+20;a[3]=j+10;
					b = new int[4];b[0]=60;b[1]=55;b[2]=60;b[3]=65;
					g.drawPolygon(a,b,4);
				}
				if(indicator3 == 5)
				{
					a = new int[4];a[0]=j;a[1]=j+10;a[2]=j+20;a[3]=j+10;
					b = new int[4];b[0]=60;b[1]=55;b[2]=60;b[3]=65;
					g.drawPolygon(a,b,4);
					g.fillPolygon(a,b,4);
				}
			}
		} 
	} //Ende GUI
}
